! Written by I. Misztal, 1998
! modification 05/31/2001 by S. Tsuruta
! last modified 01/11/2005
! Genomic Selection Options added by I. Aguilar 09/23/09
program BLUPF90
use kinds; use model;use sparsem; use sparseop; use pcg; use textop; use genomic
implicit none
real,allocatable :: y(:),&                      ! observation value
                    indata(:)                   ! one line of input data

real (rh) ::        weight_y                    ! weight for records

type (sparse_hashm)::xx
type (sparse_ija):: xx_ija
!ANNE
type (sparse_hashm)::hh
type (sparse_ija)::hh_ija
integer :: annef,annei,annej,at
!FIN ANNE
real (rh), allocatable:: xy(:),sol(:)        !storage for equations
real (rh), parameter :: set_eig=1d-5 
real (rh), allocatable :: weight_cov(:,:)
integer,allocatable:: address(:,:),&    ! start and address of each effect
                      nlevsum(:)      
integer :: neq,io,&                     ! number of equations and io-status
           data_len,&                   ! length of data record to read
           i,j,k,l,nrec,n=99,&          ! extra variables
           unit_eff,maxrounds=5000,&    ! unit number of each pedigree file
           blksize=1,mis
real (rh) ::  val
real :: second,conv_crit=1e-12,r_factor=1.4,x(3)
 character (20):: xc(3),solv_method='PCG',sol_se= ' ',&
                  prior_sol_file="solutions.prior"
logical :: residual=.false.,stdresidual=.false.,&
           first_snp,lzerosol=.true.,lprior=.false.,lchk_lev=.true.
mis=miss
 call read_parameters
! ANNE read_parameters=voir dans libs/blups1
! change defaults if optional parameters present and check positive definitness
 call defaults_and_checks()
 call defaults_and_checks_GS()
 call print_parameters('BLUPF90 1.45')
neq=ntrait*sum(nlev)
data_len=max(pos_weight,maxval(pos_y),maxval(pos_eff),maxval(nestedcov))
print*,'Data record length = ',data_len
print*,'# equations = ',neq
allocate (xy(neq),sol(neq),address(neff,ntrait),&
          weight_cov(neff,ntrait),y(ntrait),indata(data_len),nlevsum(neff))


 call setup_sum          
 
 call setup_g                    ! invert G matrices

open(io_d,file=datafile)         !data file


 call zerom(xx,neq,100000); xy=0; nrec=0
sol=0

!ANNE

! On suppose maintenant que l effet d interet est l effet neff-1 
! On suppose que l effet animal est l effet neff
! il reste donc neff-2 effets fixes

   annef=neff-1
   at=1
print *,'numero de leffet considere  ',annef
print *,'numero du caractere   ',at
!  annef=neff
 call zerom(hh,nlev(annef),100000)

  print *,'Nombre de niveau  ',nlev(annef)


!FIN ANNE

do 
   read(io_d,*,iostat=io)indata
   if (io.ne.0) exit
   nrec=nrec+1
   call decode_record
!   call find_addresses
   call find_addresses0
   call find_rinv
   do i=1,neff
       do j=1,neff
          do k=1,ntrait
             do l=1,ntrait
                 val=weight_cov(i,k)*weight_cov(j,l)*weight_y*rinv(k,l)
!                 if (val /= 0) &
                      call addm(val,address(i,k),address(j,l),xx)
             enddo
          enddo     
       enddo
       do k=1,ntrait
          do l=1,ntrait
              xy(address(i,k))=xy(address(i,k))+rinv(k,l)*y(l)*weight_cov(i,k) &
                                                              *weight_y
          enddo 
       enddo     
   enddo
enddo
!
print*,'read ',nrec,' records in ',second(),' s,  ',xx%filled,' nonzeroes'
!
!     Random effects' contributions
first_snp=.true.
do i=1,neff
   select case (randomtype(i))
     case (g_fixed)
        continue                ! fixed effect, do nothing
     case (g_diag)
        call add_g_diag(i)
     case (g_A, g_As, g_A_UPG,g_A_UPG_INB)
        unit_eff=i+io_off
        rewind unit_eff
        call add_g_add(randomtype(i),i)
        if (whichH==3 .and. first_snp) then 
           call add_genomic(i,unit_eff) 
           first_snp = .false.
        endif 
     case (g_PD)
        unit_eff=i+io_off
        rewind unit_eff
        call add_g_domin(i)
      case (g_usr)
         unit_eff=i+io_off
         rewind unit_eff
         call add_g_usr(i,'')
      case (g_usr_inv)
         unit_eff=i+io_off
         rewind unit_eff
         call add_g_usr(i,'inv')
     case default
       print*,'unimplemented random type',randomtype(i)
   endselect
enddo

print*,'finished peds in ',second(),' s,  ',xx%filled,' nonzeroes'

!
 if (neq <= 14) then
   print*,'left hand side'
   call printm(xx)
   print  '( '' right hand side:'',10(/10f8.2))',xy
 endif


if (lprior) then 
   call read_solutions(prior_sol_file)
endif 
if(solv_method == 'FSPAK') then
! Comment the line above and uncomments the lines below only if
! solutions by FSPAK desired

!ANNE
! changement de xx ici

!pour recuperer les termes de linverse pour calculer un etest F 

!**********************************************************************************************************
! finalement il suuffit de rajouter 0 et da appeler juste la combinaison d effet donc modifier aussi pour cov
!***********************************************************************************************************


    do i=1,nlev(annef)
      j=address1(annef,i,at)
      do l=i+1,nlev(annef)
        k=address1(annef,l,at)
        val=0.D0
        if (k.ge.j) then
          call addm(val,j,k,xx) 
        else
          call addm(val,k,j,xx)   
        endif       
      enddo
! Ajout pour la matrice SNP*effet fixe
      do annei=1,neff-2
        do l=1,nlev(annei)
          k=address1(annei,l,at)
          val=0.D0
          if (k.ge.j) then
            call addm(val,j,k,xx) 
          else
            call addm(val,k,j,xx)   
          endif 
        enddo
      enddo
    enddo
! Ajout pour la matrice SNP*animal
    do l=1,nlev(neff)
      k=address1(neff,l,at)
      do i=1,nlev(annef)
        j=address1(annef,i,at)
        val=getm(j,k,xx)
        if (val.ne.0) then
          do annei=1,nlev(annef)
             annej=address1(annef,annei,at)
             val=0.D0 
             if (k.ge.annej) then
               call addm(val,annej,k,xx) 
             else
               call addm(val,k,annej,xx)   
             endif 
          enddo
          go to 521
        endif          
      enddo
521   continue
    enddo 


!FIN ANNE


   xx_ija=xx
              
   call fspak90('factorize',xx_ija)
   call fspak90('solve',xx_ija,rs8=xy,sol8=sol)


elseif(solv_method == 'SOR') then
   call default_iter(conv=conv_crit,maxround=maxrounds,relax=r_factor,zerosol=lzerosol) !each parameter optional
   call solve_iterm(xx,xy,sol)
elseif(solv_method == 'PCG') then
   call default_iter(conv=conv_crit,maxround=maxrounds,zerosol=lzerosol) !each parameter optional
   call solve_pcg(xx,xy,sol,blksize)
   print *,'solutions de pcg ',sol(1)
else
   print*,'Wrong solv_method ',solv_method
   stop
endif

if (neq <=16) print  '( '' solution:'' ,10(/10f8.2))',sol

 call store_solutions
 if(residual) call write_adjusted_data 
 if(stdresidual) call write_studentized_residuals 
 contains
    
  subroutine decode_record
  ! decodes data record into y's and weight
   if (pos_weight /= 0) then
        weight_y = indata(pos_weight)
      else
        weight_y=1
   endif
   do i=1,ntrait
      y(i)=indata(pos_y(i))
   enddo
  end subroutine


 subroutine find_addresses0
! modified 09/04/2007
 integer :: i,j,lev

 do i=1,neff
    do j=1,ntrait

       select case (effecttype(i))
          case (effcross)
             if(pos_eff(i,j) > 0) then
	        lev=int(indata(pos_eff(i,j)))
                if(lchk_lev .and. lev > nlev(i) .and. nlev(i)/=0) then
                   print '(/4(a,i0)/)',' at Effect: ',i,' trait ',j,' level ',lev,' > # animals: ',nlev(i)
                   stop
	        endif
	     else
	        lev=0
	     endif
	     weight_cov(i,j)=1.0
          case  (effcov)
             if(pos_eff(i,j) > 0) then
                weight_cov(i,j)=indata(pos_eff(i,j))
             else
                weight_cov(i,j)=0
	     endif
             if(nestedcov(i,j) == 0) then
                lev=1
             elseif (nestedcov(i,j) > 0) then
                lev=int(indata(nestedcov(i,j)))
                if(lchk_lev .and. lev > nlev(i) .and. nlev(i)/=0) then
                   print '(/4(a,i0)/)',' at Effect: ',i,' trait ',j,' level ',lev,' > # animals: ',nlev(i)
                   stop
                endif
	     else
                print*,'wrong description of nested covariable'
                stop
             endif
          case default
             print*,'unimplemented effect ',i
             stop
       end select

       if (lev /= 0) then
          address(i,j)=address1(i,lev,j)
       else
          address(i,j)=1    !dummy address
          weight_cov(i,j)=0.0
       endif  
    
    enddo 
 enddo
 end subroutine


  subroutine find_addresses
! modified 10/25/2002
  integer :: i,j,lev

  do i=1,neff
     do j=1,ntrait

        select case (effecttype(i))
           case (effcross)
              if(pos_eff(i,j) >0) then
	         lev=int(indata(pos_eff(i,j)))
              else
	         lev=0
	      endif
	      weight_cov(i,j)=1.0
           case  (effcov)
              if(pos_eff(i,j) >0) then
                 weight_cov(i,j)=indata(pos_eff(i,j))
              else
                 weight_cov(i,j)=0
	      endif
              if (nestedcov(i,j) == 0) then
                  lev=1
                elseif (nestedcov(i,j) > 0) then
                  lev=int(indata(nestedcov(i,j)))
                else
                  print*,'wrong description of nested covariable'
                  stop
              endif
           case default
              print*,'unimplemented effect ',i
              stop
        end select

        if (lev /= 0) then
              address(i,j)=address1(i,lev,j)
            else
              address(i,j)=1    !dummy address
              weight_cov(i,j)=0.0
        endif  
    
     enddo 
  enddo
  end subroutine

 
  function address1(e,l,t)
! returns address for level l of effect e and trait t
  integer :: e,l,t, address1,i
  logical,save::first=.true.
  integer,allocatable,save::offset(:)
  !
  if (first) then
     first=.false.
     allocate(offset(neff))
     do i=1,neff
        offset(i)=sum(nlev(1:i-1))*ntrait
     enddo
  endif
  !
  address1= offset(e)+(l-1)*ntrait+t
  end function

 
  subroutine find_rinv
! calculates inv(Q R Q), where Q is an identity matrix zeroed for 
! elements corresponding to y(i)=mis
  interface
    subroutine ginv1(a,n,nmax,tol,rank)
     use kinds
     integer::n,nmax,rank
     real (rh)::a(nmax,nmax),tol
    end subroutine
  end interface

  integer :: i,irank
!
  rinv=r
  do i=1,ntrait
     if (y(i) == mis) then
        rinv(i,:)=0; rinv(:,i)=0
     endif
  enddo
  call ginv1(rinv,ntrait,ntrait,real(1d-8,rh),irank)
  end subroutine
  
  subroutine setup_g
! inverts g matrices
  interface
    subroutine ginv1(a,n,nmax,tol,rank)
     use kinds
     integer::n,nmax,rank
     real (rh)::a(nmax,nmax),tol
    end subroutine
  end interface
 
  integer :: rank
  
  do i=1,neff
     if (randomnumb(i).ne.0) then
         j=randomnumb(i)*ntrait
	 call pos_def(g(i,:j,:j),'G not positive definite: fixed',min_eig=set_eig)
         call printmat(g(i,:j,:j),'G','(9g12.5)')
         call ginv1(g(i,:,:),randomnumb(i)*ntrait,maxcorr,real(1d-12,rh),rank)
     endif
  enddo
  end subroutine

  subroutine add_g_diag(eff)
! adds diagonal (IID) contributions to MME
  integer :: eff, i,j,k,l,m,t1,t2
  do i=1,nlev(eff)
     do j=0,randomnumb(eff)-1
        do k=0,randomnumb(eff)-1
           do t1=1,ntrait
              do t2=1,ntrait
                 m=address1(eff+j,i,t1); l=address1(eff+k,i,t2)
!                 xx(m,l)=xx(m,l)+g(eff,t1+j*ntrait,t2+k*ntrait)
                 call addm(g(eff,t1+j*ntrait,t2+k*ntrait),m,l,xx)
              enddo
           enddo
        enddo
     enddo
  enddo
  end subroutine

  subroutine add_g_add(type,eff)
! generates contributions for additive sire or animal effects
  integer :: type,eff,i,i1,j,t1,t2,k,l,m,n,io,p(4),ped_len,nped
  real (rh) ::w(3),res(4),mendel
!
 
  select case (type)
     case (g_A)
        w=(/1., -.5, -.5/)
        res=(/2., 4/3., 1., 0./)
        ped_len=3
     case (g_A_UPG)
        w=(/1., -.5, -.5/)
        res=(/2., 4/3., 1., 0./)
        ped_len=4
     case (g_A_UPG_INB)
        w=(/1., -.5, -.5/)
        ped_len=4
     case (g_As)
        w=(/1., -.5, -.25/)
        res=(/16/11., 4/3., 16/15., 1./)
        ped_len=3
  end select

  nped=0
  do
     read(unit_eff,*,iostat=io)p(1:ped_len)
     if (io /= 0) exit
     nped=nped+1
     select case (type)
        case (g_A)
            i=1; if(p(2)==0) i=i+1; if (p(3) == 0) i=i+1
            mendel=res(i)
        case (g_A_UPG)
           mendel=res(p(4))
        case (g_A_UPG_INB)
           mendel=p(4)/1000.
        case (g_As)
            i=1; if(p(2)==0) i=i+2; if (p(3) == 0) i=i+1
            mendel=res(i)
     end select

     do i=0,randomnumb(eff) - 1
        do i1=1,3          
           if (lchk_lev .and. p(i1) > nlev(eff+i) .and. nlev(eff+i)/=0) then
              print '(/3(a,i0)/)',' at Effect: ',eff+i,' level ',p(i1),' > # animals: ',nlev(eff+i)
              stop
           endif
        enddo
        do j=0,randomnumb(eff) - 1
           do t1=1,ntrait
              do t2=1,ntrait
                 if (pos_eff(eff+i,t1)/=0 .and. pos_eff(eff+j,t2)/=0) then
                    do k=1,3
                       do l=1,3	
                          if (p(k) /=0 .and. p(l) /=0) then
                             m=address1(eff+i,p(k),t1)
                             n=address1(eff+j,p(l),t2)
                             val=g(eff,t1+i*ntrait,t2+j*ntrait)&
                                                   *w(k)*w(l)*mendel
                             call addm(val,m,n,xx)
                          endif
                       enddo
                    enddo
                 endif
              enddo
            enddo
        enddo
     enddo
  enddo
  print*,' read ',nped,' additive pedigrees'
  end subroutine

  subroutine add_g_usr(eff,text)
! generates contributions user defined matrix; if text is 'inv',
!    this matrix is inverted 
!
  integer :: eff,i,j,k,m,n,row,col,t1,t2,type=0,maxrow=0,maxcol=0,maxdiag=0
  integer,parameter::upper=1,lower=2
  real (rh) ::val,x,ident(nlev(eff)),sol(nlev(eff))
  type (sparse_hashm)::a_usr
  type (sparse_ija)::a_usr_ija
  character (*)::text
!
     call init(a_usr)
     call zerom(a_usr,nlev(eff))
     n=0

     do
        read(unit_eff,*,iostat=io)row,col,x
        if (io /= 0) exit
        n=n+1
    
       ! Only upper or lower half stiored matrices are accepted
        if (row /=col) then
           if (type == 0) then
               if (row < col) type = upper
               if (row > col) type = lower
           endif

           if ((type == upper .and. row > col) .or. &
               (type == lower .and. row < col)) then
              print*,'Mixed upper and lower diagonals in g_usr_inv:',row,col,x
              stop
           endif
        endif
        
        call addm(x,row,col,a_usr) 
        if (row /=col) call addm(x,col,row,a_usr) 
        maxrow=max(maxrow,row)
        maxcol=max(maxcol,col)
        if (row==col) maxdiag=max(maxdiag,row)
     enddo
     
     print*,'g_usr_inv: read ',n,' elements'
     if (n == 0) then
       print*,'User defined file for effect ',eff,' empty'
       stop
     endif
     
     !df_random(eff)=nlev(eff)

     print*,'largest row, column, diagonal:',maxrow,maxcol,maxdiag

  !print*,'a_usr'
  !call printm(a_usr)
  
  if (text(1:3)=='inv') then ! invert a_usr
       a_usr_ija=a_usr
       call reset(a_usr) 
       call init(a_usr)
       call zerom(a_usr,nlev(eff))
       print*,'a_usr_ija'
       !call printm(a_usr_ija)
       do i=1,nlev(eff)
          ident=0; ident(i)=1
          call fspak90('solve',a_usr_ija,ident,sol)
          do j=1,nlev(eff)
             if (sol(j) /= 0) call addm(sol(j),i,j,a_usr)
          enddo
       enddo
!       call fspak90('stat',a_usr_ija)
       call reset(a_usr_ija)
    else
       !ainv(eff)=a_usr 
  endif   
  
  if (nlev(eff) <= 20) then
     print*,'user defined matrix'
     call printm(a_usr)
  endif
     
  
  do i=0,randomnumb(eff) - 1 !loops for correlated effects
     do j=0,randomnumb(eff) - 1
        do t1=1,ntrait
           do t2=1,ntrait
              if (pos_eff(eff+i,t1)/=0 .and. pos_eff(eff+j,t2)/=0) then 
                 do k=1,a_usr%nel
                       row=a_usr%x(1,k)
                       if (row /=0) then
                           col=a_usr%x(2,k)
                           x=a_usr%x(3,k)
                           m=address1(eff+i,row,t1)
                           n=address1(eff+j,col,t2)
                           val=g(eff,t1+i*ntrait,t2+j*ntrait)*x 
                           call addm(val,m,n,xx)
!		           if (m /=n) call addm(val,n,m,xx)
                           if (row /= col) call addm(val,n,m,xx)
                       endif
                 enddo
              endif
            enddo
        enddo
     enddo
   enddo  
   call reset(a_usr)   
end subroutine


  subroutine add_g_domin(eff)
! adds parental dominance matrix using files created by RENDOMN
  integer :: eff,i,i1,j,t1,t2,k,l,m,n,io,p(10),max_class,d,nped
  real (rh) ::w(9)=(/1.0,-.5,-.5,-.5,-.5,.25,.25,.25,.25/),r(0:255)
  logical,save::first=.true.

! compute residuals for different classes of missing s-d combinations
      if (first) then
         call creatres(r)
         first=.false.
      endif

  max_class=0

!  contributions to diagonals for classes with parental classes

  nped=0
  do
     read(unit_eff,*,iostat=io)p(1:10)
     if (io /= 0) exit
     nped=nped+1
     max_class=max(max_class,p(1))
     do i=0,randomnumb(eff) - 1
        do i1=1,9
           if(lchk_lev .and. p(i1) > nlev(eff+i) .and. nlev(eff+i)/=0) then
              print '(/3(a,i0)/)',' at Effect: ',eff+i,' level ',p(i1),' > # levels: ',nlev(eff+i)
             stop
           endif
        enddo
        do j=0,randomnumb(eff) - 1
           do t1=1,ntrait
              do t2=1,ntrait
                 do k=1,9
                    do l=1,9	
                       if (p(k) /=0 .and. p(l) /=0) then
                          m=address1(eff+i,p(k),t1)
                          n=address1(eff+j,p(l),t2)
                          val=g(eff,t1+i*ntrait,t2+j*ntrait)&
                                                *r(p(10))*w(k)*w(l)
                          call addm(val,m,n,xx)
                       endif
                    enddo
                 enddo
              enddo
            enddo
        enddo
     enddo
  enddo

!  contributions to diagonals for classes without parental classes

  do d=max_class+1,nlev(eff)
     do i=0,randomnumb(eff) - 1
        do j=0,randomnumb(eff) - 1
           do t1=1,ntrait
              do t2=1,ntrait
                 m=address1(eff+i,d,t1)
                 n=address1(eff+j,d,t2)
                 val=g(eff,t1+i*ntrait,t2+j*ntrait)
                 call addm(val,m,n,xx)
              enddo
            enddo
        enddo
     enddo
  enddo

  print*,' read ',nped,' dominance pedigrees'

  end subroutine


  subroutine store_solutions
  ! store solutions in file 'solutions'

  integer e,l,t,j,effet,niveau
!ANNE
  real (rh), allocatable:: hb(:),hd(:)
  real (rh) :: hc,val
  integer al
  allocate (hb(nlev(annef)),hd(nlev(annef)))


  open(io_s,file='solu_'//datafile)
  open(io_t,file='test_'//datafile)
  open(io_mat,file='mat_'//datafile)

!FIN ANNE

 if(sol_se == 'se') then

   ! write(io_s,'(''trait/effect level  solution          s.e.'')')


    if (solv_method /= 'FSPAK') xx_ija=xx      
!ANNE
!print *,'avant '
 do i=1,nlev(annef)
      do j=i,nlev(annef)
         k=address1(annef,i,at)
         l=address1(annef,j,at)
         val=getm(k,l,xx_ija)
!         print *,'matrice   ',i,j,val
enddo
enddo 

! Impression des la matrice SNP*effet fixe avant inversion

   do i=1,nlev(annef)
     annej=0
     do annei=1,neff-2
       do j=1,nlev(annei)
         annej=annej+1
         k=address1(annef,i,at)
         l=address1(annei,j,at)        
         if (k.le.l) then
           val=getm(k,l,xx_ija)
         else
           val=getm(l,k,xx_ija)
         endif
         write (io_mat,fmt=*) "0  ",i,annej,val  
       enddo
     enddo
   enddo



!FIN ANNE

    call fspak90('inverse',xx_ija)
            
!ANNE
!print *,'inverse '
! do i=1,nlev(annef)
!      do j=i,nlev(annef)
!         k=address1(annef,i,at)
!         l=address1(annef,j,at)
!         val=getm(k,l,xx_ija)
!         print *,'matrice  ',i,j,val
!enddo
!enddo 
!FIN ANNE                        
!ANNE
!    Calcul du test

    ! Effet

print *,'effet utilise  store',annef
print *,'trait utilise  store ',at
    ! trait
!regression simple
if (nlev(annef).eq.1) then
  j=address1(annef,1,at)  
  hb(1)=sol(j)
  k=address1(annef,1,at)
  val=getm(j,k,xx_ija)
  hc=hb(1)*hb(1)/val
  write (io_t,fmt=*) "1   ",annef,hc,nlev(annef)
  print *,'test  ',hc, nlev(annef)
! Ecriture inverse SNP*SNP
  write (io_mat,fmt=*) "1  ",nlev(annef),nlev(annef),val


else  

!plusieurs genotypes ou haplotypes

    do i=2,nlev(annef)
      j=address1(annef,i-1,at)
      k=address1(annef,i,at)     
      hb(i-1)=sol(j)-sol(k)

    enddo 

    do i=1,nlev(annef)-1
      do j=i,nlev(annef)-1
         k=address1(annef,i,at)
         l=address1(annef,j,at)
         val=getm(k,l,xx_ija)
! Ecriture inverse SNP*SNP
         write (io_mat,fmt=*) "1  ",i,j,val  
       
         call addm(val,i,j,hh)
         k=address1(annef,i+1,at)
         l=address1(annef,j,at)
         if (k.le.l) then
           val=-getm(k,l,xx_ija)
         else
           val=-getm(l,k,xx_ija)
         endif
         call addm(val,i,j,hh) 
         k=address1(annef,i,at)
         l=address1(annef,j+1,at)
         val=-getm(k,l,xx_ija)
         call addm(val,i,j,hh) 
         k=address1(annef,i+1,at)
         l=address1(annef,j+1,at)
         val=getm(k,l,xx_ija)
! Ecriture inverse SNP*SNP
         if ((i.eq.nlev(annef)-1).and.(i.eq.j)) then
           write (io_mat,fmt=*) "1  ",i+1,j+1,val  
         endif

         call addm(val,i,j,hh) 

      enddo
   enddo
endif

! Impression des la matrice SNP*effet fixe

   do i=1,nlev(annef)
     annej=0
     do annei=1,neff-2
       do j=1,nlev(annei)
         annej=annej+1
         k=address1(annef,i,at)
         l=address1(annei,j,at)        
         if (k.le.l) then
           val=getm(k,l,xx_ija)
         else
           val=getm(l,k,xx_ija)
         endif
         write (io_mat,fmt=*) "2  ",i,annej,val  
       enddo
     enddo
   enddo

! Impression des la matrice SNP*animal

   do i=1,nlev(annef)
     do j=1,nlev(neff)
         k=address1(annef,i,at)
         l=address1(neff,j,at)        
         if (k.le.l) then
           val=getm(k,l,xx_ija)
         else
           val=getm(l,k,xx_ija)
         endif
         if (val.ne.0) then
           write (io_mat,fmt=*) "3  ",i,j,val  
         endif
     enddo
   enddo

if (nlev(annef).gt.1) then
!    print *,'avant ija'
    hh_ija=hh
!    print *,'avant inverse'
    call fspak90('inverse',hh_ija)
    hd=mult(hb,hh_ija)
    hc=0.D0
    do i=1,nlev(annef)-1
       hc=hc+hd(i)*hb(i)
    enddo

    hc=hc/dfloat(nlev(annef)-1)
    write (io_t,fmt=*) "1   ",annef,hc,nlev(annef)
    print *,'test  ',hc, nlev(annef)
endif


!FIN ANNE

     do e=1,neff-1  ! ANNE ecriture des effets sauf effet animal
       do l=1,nlev(e)

          do t=1,ntrait        
             j=address1(e,l,t)
	     write(io_s,fmt=fmt_sol_se)t,e,l,sol(j),sqrt(getm(j,j,xx_ija))

          enddo
       enddo
    enddo
    print*,'solutions and s.e. stored in file: "solutions"'
 else
    write(io_s,'(''trait/effect level  solution'')')
    do e=1,neff
       do l=1,nlev(e)
          do t=1,ntrait
             write(io_s,fmt=fmt_sol_se)t,e,l,sol(address1(e,l,t))
          enddo
       enddo
    enddo
    print*,'solutions stored in file: "solutions"'
 endif

  end subroutine

  subroutine read_solutions(afile)
  ! read solutions in file 'solutions'
  integer e,l,t,j,i,io
  real(rh) s
  character*(*) :: afile
  open(io_s,file=afile)

  read(io_s,*) 
  do i=1,neq
     read(io_s,fmt=fmt_sol_se,iostat=io)t,e,l,s
     if(io/=0)  exit
     sol(address1(e,l,t)) = s
  enddo
  print*,'solutions readed from file: "',afile,'"'
  close(io_s)

  end subroutine 
  
  subroutine defaults_and_checks()
  ! check optional parameters and check for positive definitness
  integer::i
  
  do
   call getoption('conv_crit',n,x,xc)
   if(n > 0) then
      read(xc(1),'(f10.0)')conv_crit
      print*,'* convergence criterion (default=1e-12):',conv_crit
   endif
   call getoption('maxrounds',n,x,xc)
   if(n > 0) then
      read(xc(1),'(i10)')maxrounds
      print*,'* maximum number of iterations (default=5000):',maxrounds
   endif
   call getoption('solv_method',n,x,xc)
   if(n > 0) then
      solv_method=xc(1)
      print*,'* solving method (default=PCG):',solv_method
   endif
   call getoption('r_factor',n,x,xc)
   if(n > 0) then
      read(xc(1),'(f10.0)')r_factor
      print*,'* relaxation factor for SOR (default=1.4):',r_factor
   endif
   call getoption('blksize',n,x,xc)
   if(n > 0) then
      read(xc(1),'(i10)')blksize
      print*,'* block size for block diagonal matrix (default=1):',blksize
   endif
   call getoption('sol',n,x,xc)
   if(n > 0) then
      sol_se=xc(1)
      print*,'*** store solutions and s.e. *** ',sol_se
   endif
   call getoption('prior_solutions',n,x,xc)
   if(n > 0) then
      prior_sol_file=xc(1)
      print*,'*** read prior solutions from file: ',prior_sol_file
      lprior=.true.
      lzerosol=.false.
   endif
   call getoption('residual',n,x,xc)
   if(n == 0) then
      residual=.true.
      print*,'* yhat and residual will be shown in yhat_residual'
      n=1
   endif
   call getoption('stdresidual',n,x,xc)
   if(n == 0) then
      stdresidual=.true.
      print*,'* yhat and student residual will be shown in yhat_student_residual'
      n=1
   endif
    call getoption('missing',n,x,xc)
    if(n > 0) then
       read(xc(1),*)mis
       print*,'* missing observation (default=0):',mis
    endif
    call getoption('check_levels',n,x,xc)
    if(n > 0) then
       if (x(1)==0) lchk_lev=.false.
       if (x(1)==1) lchk_lev=.true.
       print*,'* check levels (default=.true.):',lchk_lev
    endif   
   call getoption('end',n,x,xc)
   if(n <= 0) exit
  enddo
  
  if (stdresidual) solv_method='FSPAK'

  if(sol_se == 'se') solv_method='FSPAK' 

  call pos_def(r,'Warning !!! R not positive definite: fixed',min_eig=set_eig)
  do i=1,neff
   if (randomnumb(i).ne.0) then
       j=randomnumb(i)*ntrait
       call pos_def(g(i,:j,:j),'Warning !!! G not positive definite: fixed',min_eig=set_eig)
   endif
  enddo
  end subroutine

  subroutine write_adjusted_data
  ! write yhat and residual
  integer::i,j,k
  character (40)::form
  real :: y2(ntrait)
  form='(100f14.6)'
  rewind io_d
  open(io_s+1,file='yhat_residual')

  do j=1,nrec
    read(io_d,*,iostat=io)indata
    call decode_record
    call find_addresses
    y2=y
    do k=1,ntrait
       if (y(k) /= mis) then
          do i=1,neff
            y(k)=y(k)- weight_cov(i,k)*sol(address(i,k))
          enddo
       endif
    enddo
    if (j<10) print*, y2,y
    write(io_s+1,form)y2-y,y
  enddo

  print*,'wrote yhat and residual in file "yhat_residual"'
  end subroutine write_adjusted_data


  subroutine write_studentized_residuals
  ! compute studentized residual by e/sqrt(mse*(1-Hii)
  integer::i,j,k,l,m,ii,jj,t,e
  character (40)::form
  real :: y2(ntrait),nn(ntrait),df(ntrait)
  real(r8) :: ee(ntrait),seff(neff,ntrait),mse(ntrait)
  real(r4) :: h(ntrait)
  real(rh) ::val
  !

  !if (ntrait >1) stop 'studentized residual only for ntrait==1'

  form='(100f14.6)'
  rewind io_d
  open(io_s+1,file='yhat_student_residual')
  ee=0
  nn=0
  do j=1,nrec
    read(io_d,*,iostat=io)indata
    call decode_record
    call find_addresses
    y2=y
    do k=1,ntrait
       if (y(k) /= mis) then ! mis
          nn(k)=nn(k)+1
          do i=1,neff
            !y(k)=y(k)- weight_cov(i,k)*weight_y*sol(address(i,k))
            y(k)=y(k)- weight_cov(i,k)*sol(address(i,k))
          enddo
       endif
    enddo
    y=y*sqrt(weight_y)

    
    where(y2/=mis)
       ee=ee+y**2
    endwhere
  enddo

  df=0
  do t=1, ntrait
     do e=1,neff
        do l=1,nlev(e)
           if (sol(address1(e,l,t))/=0.d0) then 
              df(t)=df(t)+1
           endif
        enddo 
     enddo 
  enddo 

  if(sol_se /= 'se') call fspak90('inverse',xx_ija,rank=i)
  !xrank = i  
  xx=xx_ija
  print '(a)','wrote yhat and student residual in file "yhat_student_residual"'
  print '(a)','sum(e**2) '
  print '(10(f15.2,x))',ee
  print '(a)','nrec '
  print '(10i10)',int(nn)
  print '(a)','parameters sol /=0'
  print '(10i10)',int(df)
  print '(a)','error df'
  print '(10i10)',int(nn-df)
  print '(a)','MSE '
  print '(10f10.3)',ee/(nn-df)

  mse=ee/(nn-df)

  if (neq<10) call printm(xx_ija)
  rewind io_d
  do i=1,nrec 
     read(io_d,*,iostat=io)indata
     call decode_record
     call find_addresses

     ! get residual
     y2=y
     do k=1,ntrait
        if (y(k) /= mis) then ! mis
           do j=1,neff
            y(k)=y(k)- weight_cov(j,k)*sol(address(j,k))
           enddo
        endif
     enddo


     !  get diagonal of Hat matrix
     seff=0
     h=0
     do k=1,ntrait
        if (y(k) == mis) cycle
        do l=1,neff
           ii = address(l,k)
           do m=1,neff
              jj = address(m,k)
              if (ii>jj) then
                 !val=getm(jj,ii,xx_ija)
                 val=getm(jj,ii,xx) 
              else
                 !val=getm(ii,jj,xx_ija)
                 val=getm(ii,jj,xx)
              endif
              seff(m,k)=seff(m,k) + weight_cov(l,k)*weight_y*val*rinv(k,k)
           enddo 
        enddo 
        do m=1,neff
           h(k) = h(k) + seff(m,k)*weight_cov(m,k)
        enddo 
     enddo 
    
     h=min(h,real(1,kind(h)))
 
     ee=0
     where (h/=1.d0) 
        ee=y/(sqrt(mse*(1.d0-h))/sqrt(weight_y))
     endwhere

     if (i<10) print*, y2,y,ee,sqrt(mse*(1.d0-h))/sqrt(weight_y),h
     write(io_s+1,form)ee
     !write(999,'(100f30.20)') h
  enddo  ! nrec 
  end subroutine write_studentized_residuals

  subroutine setup_sum
     do i=1, neff
        nlevsum(i)=sum(nlev(1:i-1))
     enddo
  end subroutine
 
  subroutine add_genomic(i,unit)
  integer :: i,unit
  !
  call setup_genomic(i,unit)           
  if (sameWeights) then 
     !print*,'wGimA22i',wGimA22i
     call add_g_usr_gs(xx,i,nlevsum,randomnumb(i),ntrait,GimA22i,wGimA22i)
  else
     !print*,'wGi,wA22i',wGi,wA22i
     call add_g_usr_gs(xx,i,nlevsum,randomnumb(i),ntrait,Gi,wGi)           
     call add_g_usr_gs(xx,i,nlevsum,randomnumb(i),ntrait,A22i,wA22i)
  endif
  end subroutine 
end program blupf90
 

