module model
use kinds
implicit none

!        Types of effects
integer,parameter::effcross=0,& !effects can be cross-classified 
                   effcov=1     !or covariables

!        Types of random effects
integer,  parameter ::  g_fixed=1,&       ! fixed effect
                        g_diag=2, &       ! diagonal
                        g_A=3, &          ! additive animal
                        g_A_UPG=4, &      ! additive animal with unknown
                                          !       parent groups
                      & g_A_UPG_INB=5, &  ! additive animal with unknown
                                          !       parent groups and inbreeding
                      & g_As=6,&          ! additive sire
                        g_PD =7, &         ! parental dominance
			g_usr=8,&	  ! user defined
			g_usr_inv=9,&	  ! user defined and inverted
                        g_A_UnSym=10,&    ! additive animal unsymetric 
                        g_last=11          ! last type

character (40)     ::   parfile, &     !name of parameter file
                        datafile       !name of data set

integer :: ntrait,&                    !number of traits
           neff,&                      !number of effects
           miss=0                      !value of missing trait/effect
 

integer,allocatable :: pos_y(:)        !positions of observations
integer ::             pos_weight      ! position of weight of records; zero if none


integer,allocatable :: pos_eff(:,:),&  !positions of effects for each trait
                       nlev(:),&       !number of levels
                       effecttype(:),& !type of effects
                       nestedcov(:,:),&!position of nesting effect for each trait
                                       ! if the effect is nested covariable
                     & randomtype(:),& ! status of each effect, as above
                       randomnumb(:)   ! number of consecutive correlated effects

character (40),allocatable::  randomfile(:)   ! name of file associated with given effect

real (rh), allocatable :: r(:,:),&      !residual (co)variance matrix
                          rinv(:,:),&   ! and its inverse
                          g(:,:,:)      ! The random (co)variance matrix for each trait

integer,parameter::   maxcorr=50,&     ! maximum number of correlated effects; used for g 50 
                      io_off=102,&      ! unit number = i+io_off for effect i 50
                      io_d=50,&        ! unit number for data file 
                      io_s=30,&        ! unit number for solution file et +1 y_hat 
                      io_t=300,&       !ANNE unit number for test file change de 31 a 200
                      io_tt=301,&      !ANNE unit number composante variance  201
                      io_mat=302,&     !ANNE unit number pour les matrices pour Muller&Piepho
                      io_p=40          ! unit number for parameter file

character(50) ::      fmt_sol_se=        '(2i4,i10,2f16.8)',&                        ! format for solutions file (sol and se)
                      fmt_sol_acc=       '(2i4,i10,2(f16.8,f8.4))',&                 ! format for sol_and_acc file (animal and/or maternal)
                      fmt_sol_acc_pavg=  '(2i4,i10,f16.8,f8.4,f16.8,i3,2i10,f8.4)',& ! as before but with pavg info
                      fmt_gibbs_samples= '(1000(7g12.4/))'                           ! format in gibbs_samples

end module model

